C*********************************************************************
 
C...PYGRAM
C...Universal Extra Dimensions Model (UED)
C...Computation of the Graviton mass.

      SUBROUTINE PYGRAM

C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
      INTEGER PYK,PYCHGE,PYCOMP
C...UED Pythia common
      COMMON/PYPUED/IUED(0:99),RUED(0:99)
C...Local variables
      INTEGER KKFLA
      PARAMETER(KKFLA=450)
      INTEGER NDIM,IGAMKK,IS
      DOUBLE PRECISION PCUJET,XMGAM,Y,DGDMAX,AMMAX,AMMIN,X
     &        ,DGADMG,PI,RMG,XMGAMK
C...Pythia commonblocks
      INTEGER KCHG
      DOUBLE PRECISION PMAS,PARF,VCKM
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)      

      IS=-1
      PCUJET=1.
      NDIM=IUED(2)
      PI=DACOS(-1.D0)

C...Compute (dGamma/dMg)_max (analytical expression)
      IGAMKK=KKFLA+23
      XMGAMK=PMAS(IGAMKK,1)
      XMGAM=PMAS(22,1)
      Y = 2.*PCUJET/XMGAMK
      
      DGDMAX = ((1-Y)**(0.5*(NDIM+1)))*(1./Y)
     &          *(1.+DCOS(PI*DSQRT(1.-Y)))

      AMMAX=DSQRT(XMGAMK**2-XMGAM**2-
     &   2.*XMGAMK*DSQRT(PCUJET**2+XMGAM**2))
      AMMIN=0.
      IF(AMMAX.LT.AMMIN)THEN
         WRITE(MSTU(11),*) 'WARNING: ERROR ON SAMPLED MG '
         PMAS(39,1)=0.D0
         RETURN
      ENDIF

 331  RMG=AMMIN+(AMMAX-AMMIN)*PYR(0)
      X=RMG/XMGAMK
      DGADMG=X**(NDIM+1)*(1./(1.-X**2))*(1.+DCOS(PI*X))
      
C...keep the sampled Mg with a probability dGammadMg/dGdMax
C...this way the sample Mg's will correspond to the dGamma distribution      
      IF(DGADMG/DGDMAX.LT.PYR(0)) GOTO 331

      PMAS(39,1)=RMG

      IS=0
      RETURN
      END
